// Generated by gmmproc 2.82.0 -- DO NOT MODIFY!
#ifndef _GTKMM_MULTISELECTION_H
#define _GTKMM_MULTISELECTION_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 2020 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glibmm/object.h>
#include <glibmm/refptr.h>
#include <giomm/listmodel.h>
#include <gtkmm/selectionmodel.h>
#include <gtk/gtk.h> // Declares GtkMultiSelection and GtkMultiSelectionClass


#ifndef DOXYGEN_SHOULD_SKIP_THIS
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Gtk
{ class GTKMM_API MultiSelection_Class; } // namespace Gtk
#endif //DOXYGEN_SHOULD_SKIP_THIS

namespace Gtk
{
//TODO: Derive from (and implement) SectionModel when we can break ABI.
/** A selection model that allows selecting multiple items.
 *
 * %Gtk::MultiSelection is an implementation of the Gtk::SelectionModel interface
 * that allows selecting multiple elements.
 *
 * @see SelectionModel
 * @ingroup ListView
 * @newin{3,98}
 */

class GTKMM_API MultiSelection : public Glib::Object, public Gio::ListModel, public SelectionModel
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  using CppObjectType = MultiSelection;
  using CppClassType = MultiSelection_Class;
  using BaseObjectType = GtkMultiSelection;
  using BaseClassType = GtkMultiSelectionClass;

  // noncopyable
  MultiSelection(const MultiSelection&) = delete;
  MultiSelection& operator=(const MultiSelection&) = delete;

private:  friend class MultiSelection_Class;
  static CppClassType multiselection_class_;

protected:
  explicit MultiSelection(const Glib::ConstructParams& construct_params);
  explicit MultiSelection(GtkMultiSelection* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:

  MultiSelection(MultiSelection&& src) noexcept;
  MultiSelection& operator=(MultiSelection&& src) noexcept;

  ~MultiSelection() noexcept override;

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GtkMultiSelection*       gobj()       { return reinterpret_cast<GtkMultiSelection*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GtkMultiSelection* gobj() const { return reinterpret_cast<GtkMultiSelection*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GtkMultiSelection* gobj_copy();

private:

  
protected:
  MultiSelection();
    explicit MultiSelection(const Glib::RefPtr<Gio::ListModel>& model);


public:
  
  static Glib::RefPtr<MultiSelection> create();

  
  static Glib::RefPtr<MultiSelection> create(const Glib::RefPtr<Gio::ListModel>& model);


  /** Returns the underlying model of @a self.
   * 
   * @return The underlying model.
   */
  Glib::RefPtr<Gio::ListModel> get_model();
  
  /** Returns the underlying model of @a self.
   * 
   * @return The underlying model.
   */
  Glib::RefPtr<const Gio::ListModel> get_model() const;
  
  /** Sets the model that @a self should wrap.
   * 
   * If @a model is <tt>nullptr</tt>, @a self will be empty.
   * 
   * @param model A `Gio::ListModel` to wrap.
   */
  void set_model(const Glib::RefPtr<Gio::ListModel>& model);

  /** The type of items. See Gio::ListModel::get_item_type().
   * 
   * @newin{4,8}
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< GType > property_item_type() const;


  /** The list managed by this selection.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< Glib::RefPtr<Gio::ListModel> > property_model() ;

/** The list managed by this selection.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gio::ListModel> > property_model() const;

  /** The number of items. See Gio::ListModel::get_n_items().
   * 
   * @newin{4,8}
   *
   * Default value: 0
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< unsigned int > property_n_items() const;


  // There are no signals or vfuncs.


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Gtk


namespace Glib
{
  /** A Glib::wrap() method for this object.
   *
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gtk::MultiSelection
   */
  GTKMM_API
  Glib::RefPtr<Gtk::MultiSelection> wrap(GtkMultiSelection* object, bool take_copy = false);
}


#endif /* _GTKMM_MULTISELECTION_H */

